#include "zcommon.acs"
#library "dakka"

#include "commonFuncs.h"

#include "dakkaConst.h"

#include "dakkaPickups.h"
#include "dakkaMsgs.h"

#include "dakkaArmor.h"
#include "dakkaHealth.h"
#include "dakkaWeps.h"
#include "dakkaCustomInv.h"
#include "dakkaScore.h"

#include "dakkaStartConst.h"

#include "dakkaFuncs.h"

#include "dakka_pickup.h"
#include "dakka_score.h"

int OpenScriptRunning = 0;

int CVar_JumpMod;
int CVar_ScrapFactor;
int CVar_StartMode;
int CVar_ScrapperStart;

script 381 OPEN
{
    if (OpenScriptRunning) { terminate; }

    IsServer = 1;
    OpenScriptRunning = 1;
    int usesCvarinfo = d_cvarinfo();
    int rearmvar, rearmval;
    int points, i;

    CalcTotalMonsterPoints();
    Log(s:"average points: ", d:MapStart_AveragePoints);

    // Determine points needed for full heal
    
    i = middle(P_FULLHEAL_MIN, FixedMul(MapStart_BaseMonsters, P_FULLHEAL_PERCENT), P_FULLHEAL_MAX);

    points = MapStart_AveragePoints * i;
    points = ((points + 2500) / 5000) * 5000; // Round to nearest 2500
    MapStart_FullHealPoints = max(5000, points);
    Log(s:"full heal points: ", d:MapStart_FullHealPoints);

    d_defaultcvar("dakka_jumpmod",  0);
    d_defaultcvar("dakka_startmode", 0);
    d_defaultcvar("dakka_2brutal", 0);
    d_defaultcvar("dakka_scrapperstart", 0);

    if (!GetCVar("dakka_zan_setscrap") && !usesCvarinfo)
    {
        d_setcvar("dakka_scrapfactor", 100);
        d_setcvar("dakka_zan_setscrap", 1);
    }

    if (!usesCVarinfo)
    {
        for (i = 0; i < AMMOTYPES; i++)
        {
            rearmvar = CVar_Rearm_Names[i];
            rearmval = GetCVar(rearmvar);

            if (!rearmval)
            {
                d_setcvar(rearmvar, 0);
            }
        }
    }

    CalculateMapAmmoCount();

    while (1)
    {
        CVar_JumpMod        = GetCVar("dakka_jumpmod");
        CVar_ScrapFactor    = middle(0, GetCVar("dakka_scrapfactor"), 1000000);
        CVar_StartMode      = GetCVar("dakka_startmode");
        CVar_ScrapperStart  = GetCVar("dakka_scrapperstart");

        for (i = 0; i < AMMOTYPES; i++)
        {
            rearmvar = CVar_Rearm_Names[i];
            rearmval = GetCVar(rearmvar);

            CVar_Rearm[i] = rearmval;
        }

        Delay(1);
    }
}

script 382 ENTER
{
    ACS_ExecuteWithResult(384, 0);
}

script 383 RESPAWN
{
    ACS_ExecuteWithResult(384, 1);
}

script 384 (int respawning)
{
    int pln = PlayerNumber();
    int mytid;
    int latest, i, j, k, ang;

    int isbrutal = 0;
        
    i = unusedTID(37000, 47000);

    // HEY TERM LOOK HERE
    if (Spawn("BrutalPistol", GetActorX(0), GetActorY(0), GetActorZ(0), i))
    {
        Thing_Remove(i);
        isbrutal = 1;
    }

    if (GetCVar("dakka_2brutal") > 0)
    {
        isbrutal = 1;
    }

    int leftfire, rightfire;
    int infammo;
    int oldjumpmod = CVar_JumpMod+1;

    int score = PlayerMapScores[pln], invScore, lastScore;

    int mylock = Timer();
    DakkaSpawnLocks[pln] = mylock;

    int canSSG;
    int ssgDownTime = 0;
    int scrapDivisor;
    int scrapToGive;

    int name, threshold, count;
    int ground = 1, wasGround, floorHeight;

    if (!OpenScriptRunning) { ACS_ExecuteWithResult(381); }

    for (i = 0; i < SCOREWEPS; i++)
    {
        for (j = 0; j < SCOREFIREMODES; j++)
        {
            PlayerWeapons_LastFired[pln][i][j] = -1;
        }
    }

    PlayerKillStreaks[pln][KS_COUNT]    =  0;
    PlayerKillStreaks[pln][KS_TIME]     = -1;
    PlayerKillStreaks[pln][KS_TIMEADD]  =  0;

    for (i = 0; i < BONUSCOUNT; i++)
    {
        BonusValues[pln][i] = 0;
    }

    if (!respawning)
    {
        PlayerMapScores[pln] = 0;

        if (DakkaClassNum() == Cl_Dakkaguy && !CheckInventory("HubTracker"))
        {
            Dakka_StartMap(CVar_StartMode);
        }

        GiveInventory("HubTracker", 1);
    }

    if (DakkaClassNum() == Cl_Dakkaguy)
    {
        for (i = 0; i < AMMOTYPES; i++)
        {
            name        = DakkaAmmoLookup[i];
            threshold   = CVar_Rearm[i];
            count       = CheckInventory(name);
            if (threshold > count) { GiveInventory(name, threshold - count); }
        }

        if (CVar_ScrapperStart && !CheckInventory(" B-Scrapper "))
        {
            i = CheckInventory("DakkaScrap");
            GiveInventory(" B-Scrapper ", 1);
            TakeInventory("DakkaScrap", CheckInventory("DakkaScrap") - i);
        }
    }

    while (DakkaSpawnLocks[pln] == mylock)
    {
        mytid = defaultTID(-1);
        DakkaTIDs[pln] = mytid;

        // LOOK HERE TOO
        // SEE I CAN BE HELPFUL
        if (isbrutal && !isDead(0))
        {
            k = unusedTID(23000, 33000);

            for (i = 0; i < 2; i++)
            {
                ang = random(0, 1.0);
                j = 0;

                while (!Spawn("GetThatShitOutOfHere", GetActorX(0) + (8192 * sin(ang)),
                                                      GetActorY(0) + (8192 * cos(ang)),
                                                      GetActorZ(0) + j, k)
                    && (j < 256.0))
                {
                    j += 16.0;
                }
            }

            Thing_Hate(k, mytid, 2);
            Thing_ChangeTID(k, 0);
        }

        // TempChecks does not need to use PlayerNumber(), since all the values
        // are decided and reset every loop.
        
        canSSG = (CheckInventory("DakkaShells") >= 2) || (CheckInventory("DakkaGyroShells") >= 2);

        if (isDead(0))
        {
            for (i = 0; i < TMP_CHECKVARS; i++) { TempChecks[i] = 0; }
        }
        else
        {
            TempChecks[TMP_LEFTFIRE]   = keyDown(BT_ATTACK);
            TempChecks[TMP_RIGHTFIRE]  = keyDown(BT_ALTATTACK);
            TempChecks[TMP_LEFTCLICK]  = keyPressed(BT_ATTACK);
            TempChecks[TMP_RIGHTCLICK] = keyPressed(BT_ALTATTACK);

            i = CheckInventory("DakkaSSG_ShotsFired") >= 2;
            i = i && canSSG;
            TempChecks[TMP_RELOADSSG]  = i;
        }

        TempChecks[TMP_INFINITEAMMO] = GetCVar("sv_infiniteammo");

        // The CheckInventory stuff is online optimization
        //  any GiveInventory or TakeInventory is sent over the internet
        //  so don't do it if you don't need to do it

        for (i = 0; i < TMP_CHECKVARS; i++)
        {
            j = TempItems[i];

            if (TempChecks[i])  { if (!CheckInventory(j)) { GiveInventory(j, 1);          } }
            else                { if ( CheckInventory(j)) { TakeInventory(j, 0x7FFFFFFF); } }
        }

        // Score, since every class should at least be able to see it
        if (CtoS_NoScore[pln])
        {
            PlayerMapScores[pln] = 0;
        }

        lastScore   = score;
        score       = PlayerMapScores[pln];
        invScore    = CheckInventory("DakkaScoreItem");
        i = score - invScore;

        if (i > 0) { GiveInventory("DakkaScoreItem",  i); }
        if (i < 0) { TakeInventory("DakkaScoreItem", -i); }

        // Rewards (all classes)
        i = MapStart_FullHealPoints;

        if (!isDead(0))
        {
            if ((lastScore / i) < (score / i))
            {
                ACS_ExecuteWithResult(648, 11);
            }
        }
        
        // Debug shit
        if (ConsolePlayerNumber() != -1 && GetCVar("dakka_cl_debug") > 0)
        {
            for (i = 0; i < SCOREWEPS; i++)
            {
                SetHudSize(640, 480, 1);
                k = 27000 + (i * (SCOREFIREMODES + 1));
                HudMessage(d:i, s:":"; HUDMSG_PLAIN, k, CR_WHITE, 470.2, 72.0 + (12.0 * i), 1.0);

                for (j = 0; j < SCOREFIREMODES; j++)
                {
                    HudMessage(d:PlayerWeapons_LastFired[pln][i][j];
                        HUDMSG_PLAIN, k+j+1, j, 510.4 + (40.0 * j), 72.0 + (12.0 * i), 1.0);
                }
            }
        }

        // For the Air bonus
        wasGround = ground;
        ground = onGround(0);

        if (ground)
        {
            floorHeight = GetActorZ(0);
            PlayerZHeight[pln] = 0;
        }
        else
        {
            i = GetActorVelZ(0) + (GetActorProperty(0, APROP_Gravity) >> 1);
            i = GetActorZ(0) + HeightFromJumpZ(i,  GetActorProperty(0, APROP_Gravity));
            i = min(i, GetActorCeilingZ(0)) - floorHeight;
            PlayerZHeight[pln] = max(PlayerZHeight[pln], i);
        }

        // For SBARINFO
        i = GetActorProperty(0, APROP_Health);
        SetInventory("HealthOver200",  max(201, i) == i);
        SetInventory("HealthOver100",  middle(101, i, 200) == i);

        /*
         * Dakkaguy-only stuff from here on out
         */

        if (DakkaClassNum() != Cl_Dakkaguy)
        {
            Delay(1);
            continue;
        }

        translateAmmo();
        translateGuns();
        removeAlienAmmo();

        if (CheckInventory("DakkaSSG_ShotsFired"))
        {
            ssgDownTime += 1;

            if (ssgDownTime >= 70 && !CheckWeapon(" B-Super Shotgun ") && canSSG)
            {
                TakeInventory("DakkaSSG_ShotsFired", 0x7FFFFFFF);
            }
        }
        else
        {
            ssgDownTime = 0;
        }

        scrapDivisor  = FixedDiv(SCRAPBASE * CVar_ScrapFactor, 100.0);
        i = CheckInventory(" B-Scrapper ");

        scrapToGive = CheckInventory("GiveScrapCounter") / scrapDivisor;
        
        if (scrapToGive)
        {
            GiveAmmo("DakkaScrap", scrapToGive);
            TakeInventory("GiveScrapCounter", scrapToGive * scrapDivisor);
        }

        // Scrap 2 (cells)
        scrapToGive = CheckInventory("GiveScrapCounter2") / scrapDivisor;
        scrapToGive = (scrapToGive / CELLSCRAP_BATCH) * CELLSCRAP_BATCH;
        
        if (scrapToGive)
        {
            GiveAmmo("DakkaScrap", scrapToGive);
            TakeInventory("GiveScrapCounter2", scrapToGive * scrapDivisor);
        }

        // Scrap 2 (flamer)
        scrapToGive = CheckInventory("GiveScrapCounter3") / scrapDivisor;
        scrapToGive = (scrapToGive / FLAMERSCRAP_BATCH) * FLAMERSCRAP_BATCH;
        
        if (scrapToGive)
        {
            GiveAmmo("DakkaScrap", scrapToGive);
            TakeInventory("GiveScrapCounter3", scrapToGive * scrapDivisor);
        }

        if (CVar_JumpMod != oldjumpmod)
        {
            SetActorProperty(0, APROP_JumpZ, JumpZFromHeight(32 + CVar_JumpMod, 1.0));
        }

        int hasbpak = 0;

        for (i = 0; i < BPAKTYPES; i++)
        {
            if (CheckInventory(DakkaBackpackLookup[i]))
            {
                hasbpak = 1;
            }
        }

        SetInventory("GotScrapper",     CheckInventory(" B-Scrapper "));
        SetInventory("GotBackpackItem", hasbpak);

        
        oldjumpmod = CVar_JumpMod;
        Delay(1);
    }
}

script 385 open clientside
{
    int usesCvarinfo = d_cvarinfo();
    int cpln = ConsolePlayerNumber();

    Client_Class = -1;
    Client_Score = -1;

    d_defaultcvar("dakka_cl_moremessages", 0);
    d_defaultcvar("dakka_cl_recoil", 0);
    d_defaultcvar("dakka_cl_jerkyrecoil", 0);
    d_defaultcvar("dakka_cl_lesseffects", 0);
    d_defaultcvar("dakka_cl_noscore", 0);
    d_defaultcvar("dakka_cl_notracers", 0);

    while (1)
    {
        int i, j;

        for (i = 0; i < PLAYERMAX; i++)
        {
            for (j = 0; j < PICKUPCOUNT; j++)
            {
                Client_GotPickup[i][j] = 0;
            }
        }

        if (PlayerInGame(cpln) && !GetCVar("dakka_cl_noscore"))
        {
            DrawScore(max(0, Client_Score));
        }

        Delay(1);
    }
}

script 386 enter clientside
{
    int pln = PlayerNumber();
    int cpln = ConsolePlayerNumber();
    int cvarinfo = GetCVar("dakka_usescvarinfo") == 138973;
    int myClient = pln == cpln;
    int i;
    int pswitch = 0;
    int changed = 0;
    int time = 0;
    int topuke;
    int flags = 0, oflags;

    while (1)
    {
        if (!myClient) { Delay(1); time++; continue; }

        Client_Class = DakkaClassNum();

        oflags = flags;
        flags = 0;

        flags |= !!(GetCVar("dakka_cl_noscore")) << 0;

        if (PlayerInGame(cpln))
        {
            Client_Score = CheckInventory("DakkaScoreItem");
        }

        if (cvarinfo) { i = cond(GetCVar("neverswitchonpickup"), 0, 2); }
        else          { i = GetCVar("switchonpickup"); }

        changed = 0;

        if (pswitch != i)
        {
            pswitch = i;
            changed = 1;
        }

        if (oflags != flags)
        {
            changed = 1;
        }

        if (changed || (time == 0))
        {
            if (IsServer)
            {
                ACS_ExecuteWithResult(388, flags, pswitch);
            }
            else if (myClient)
            {
                topuke = StrParam(s:"puke -388 ", d:flags, s:" ", d:pswitch);
                ConsoleCommand(topuke);
            }
        }

        Delay(1);
        time++;
    }

    if (myClient)
    {
        Client_Class = -1;
    }
}

script 388 (int flags1, int pswitch) net
{
    int pln = PlayerNumber();

    CtoS_NoScore[pln]        = flags1 & 0x00000001;
    CtoS_SwitchOnPickup[pln] = pswitch;
}

script 473 (int count, int high, int low)
{
    int ret = 0;
    int i;
    if (!low) { low = -high; }

    for (i = 0; i < count; i++) { ret += random(low, high); }
    SetResultValue(ret);
}

script 474 (int recoilInt, int recoilFrac, int jumpanMult)
{
    int dx; int dy; int dz;
    int jump = canJump();
    int recoil = (recoilInt * 1.0) + (recoilFrac * 0.01);

    int angle = GetActorAngle(0);
    int pitch = GetActorPitch(0);

    if (jumpanMult == 0) { jumpanMult = 100; }

    // if 1, apply multiplier when aiming down
    // if 0, apply multiplier when not aiming down
    int multJump = 1;
    if (jumpanMult < 0) { jumpanMult = -jumpanMult; multJump = 0; }

    int doMult = pitch > 0.05;
    doMult = (multJump && doMult) || !(multJump || doMult);

    if (doMult)
    {
        recoil = FixedMul(recoil, jumpanMult * 0.01);
    }
    
    if (jump)
    {
        dx = FixedMul(cos(angle), recoil);
        dx = -FixedMul(dx, cos(pitch));
        
        dy = FixedMul(sin(angle), recoil);
        dy = -FixedMul(dy, cos(pitch));
    
        dz = FixedMul(sin(pitch), recoil);
    }
    else
    {
        dx = -FixedMul(cos(angle), recoil);
        dy = -FixedMul(sin(angle), recoil);
        dz = 0;
    }

    SetActorVelocity(0, dx, dy, dz, 1, 1);
}


script 585 (int divI, int divF, int divF1)
{
    int div = percFloat2(divI, divF, divF1);
    
    int x = GetActorVelX(0);
    int y = GetActorVelY(0);
    int z = GetActorVelZ(0);
    
    SetActorVelocity(0, FixedMul(x, div), FixedMul(y, div), FixedMul(z, div), 0, 1);
}

script 586 (int speedInt, int speedFrac)
{
    int x = GetActorVelX(0);
    int y = GetActorVelY(0);
    int z = GetActorVelZ(0);
    int mag = magnitudeThree_f(x, y, z);
    int speed = percFloat(speedInt, speedFrac);

    if (mag <= 0.05) { terminate; }

    x = FixedMul(FixedDiv(x, mag), speed);
    y = FixedMul(FixedDiv(y, mag), speed);
    z = FixedMul(FixedDiv(z, mag), speed);

    SetActorVelocity(0, x, y, z, 0, 1);
}

int BFGSoundIndex[PLAYERMAX] = {0};

script 648 (int which, int a1, int a2)
{
    int pln = PlayerNumber();
    int i;
    int ret = 0;

    switch (which)
    {
      case 0:
        if (a1 == 0) { a1 = 4; }
        if (a2 == 0) { a2 = 7; }
        i = (a2 - a1) + 1;
        ret = (BFGSoundIndex[pln]++ % i) + a1;
        break;

      case 1:
        ret = (CheckInventory("DakkaRockets") - CheckInventory("DakkaRocketsLoaded")) > 0;
        ret |= CheckInventory("DakkaInfiniteAmmo");
        break;

      case 2:
        if (isSinglePlayer()) { break; }

        SetActivatorToTarget(0);
        int firer = PlayerNumber();

        if (firer == -1) { break; } // Don't run on non-players
        if (!a2 && !isCoop()) { break; }

        for (i = 0; i < PLAYERMAX; i++)
        {
            if (!PlayerInGame(i)) { continue; }

            // If "only explode for firer" is being set and this isn't the firer,
            if (a1 == 1 && i != firer)
            {
                GiveActorInventory(DakkaTIDs[i], "DakkaUnshootable", 1);
            }
            else
            {
                GiveActorInventory(DakkaTIDs[i], "DakkaShootable", 1);
            }
        }
        break;

      case 3:
        ret = CheckInventory("DakkaSSG_ShotsFired") >= 2;
        break;

      case 4:
        ret = 0;
        ret = ret || keyPressed(BT_ATTACK);
        ret = ret || keyPressed(BT_ALTATTACK);
        ret = ret && CheckInventory("DakkaSSG_ShotsFired") < 2;
        break;

      case 5:
        switch (a1)
        {
          default:
            removeAlienAmmo();
            break;

          case 1:
            translateAmmo();
            break;
        }

        break;

      case 6:
        ret = GetActorProperty(0, APROP_Dropped);
        break;

      case 7: // cos from velocity re. pitch
      case 8: // sin from velocity re. pitch
        int x = GetActorVelX(0);
        int y = GetActorVelY(0);
        int z = GetActorVelZ(0);
        int mag = magnitudeThree_f(x, y, z);
        if (mag == 0)
        {
            if (which == 8) { ret = 0.0; }
            else { ret = 1.0; } 
        }
        else
        {
            if (which == 8) { ret = z; }
            else { ret = magnitudeTwo_f(x, y); }

            ret = FixedDiv(ret, mag);
        }
        break;

      case 9:
        if (a1 == 0) { a1 = 1; }
        if (a1 < 0) { TakeInventory("DakkaSSG_ShotsFired", -a1); }
        else        { GiveInventory("DakkaSSG_ShotsFired",  a1); }
        break;

      case 10:
        SetActivatorToTarget(0);

        switch (a1)
        {
          case 0: ret = GetActorX(0); break;
          case 1: ret = GetActorY(0); break;
          case 2: ret = GetActorZ(0); break;
        }
        break;

      case 11:
        FadeRange(255, 255, 255, 0.2, 255, 255, 255, 0, 0.5);
        ActivatorSound("dakka/pointreward", 127);
        Delay(24);

        if (isDead(0))
        {
            ActivatorSound("dakka/fizzle", 127);

            while (isDead(0)) { Delay(1); }
        }

        ActivatorSound("dakka/fullheal", 127);
        FadeRange(255, 255, 0, 0.5, 255, 255, 0, 0, 0.5);

        SetActorProperty(0, APROP_Health, getMaxHealth() * 3);
        break;
    }

    SetResultValue(ret);
}

script 455 (int which, int xoff, int yoff)
{
    int x, y, z, px, py, pz, pa;
    x = GetActorX(0); y = GetActorY(0); z = GetActorZ(0);

    int pln = PlayerNumber();
    int tid = defaultTID(-1);

    SetActivatorToTarget(0);
    px = GetActorX(0); py = GetActorY(0); pz = GetActorZ(0);
    pa = GetActorAngle(0);

    int ptid = defaultTID(-1);

    int ax, ay, az;

    switch (which)
    {
      case 0:
        ACS_ExecuteAlways(459, 0, x,y,z);
        break;
    
      case 1:
        ACS_ExecuteWithResult(460, x,y,z);
        ACS_ExecuteAlways(461, 0, x,y,z);
        ACS_ExecuteAlways(463, 0, px,py,pz);
        break;

      case 2:
        px += xoff * cos(pa);
        px += yoff * sin(pa);

        py += xoff * sin(pa);
        py -= yoff * cos(pa);

        pz += GetActorViewHeight(ptid) - 9.0;

        ax = packShorts(ftoi(px), ftoi(x));
        ay = packShorts(ftoi(py), ftoi(y));
        az = packShorts(ftoi(pz), ftoi(z));

        ACS_ExecuteAlways(465, 0, ax, ay, az);
        break;
    }
}

script 459 (int tx, int ty, int tz) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }

    int i;
    int x, y, z;
    int vx, vy, vz, mag, magI;

    int tid = defaultTID(-1);

    x  = GetActorX(0); y =  GetActorY(0);  z = GetActorZ(0) + GetActorViewHeight(tid) - 21.0;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    int density = cond(GetCVar("dakka_cl_lesseffects") > 0, 20, 8);

    for (i = 48; i < magI; i += density)
    {
        Spawn("DakkaPlasmaTrail", x+(vx*i), y+(vy*i), z+(vz*i));
    }
}

script 465 (int x, int y, int z) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }
    if (GetCvar("dakka_cl_notracers") > 0) { terminate; }

    int i;
    int tx, ty, tz;
    int vx, vy, vz, mag, magI;

    tx = itof(rightShort(x));
    ty = itof(rightShort(y));
    tz = itof(rightShort(z));

    x = itof(leftShort(x));
    y = itof(leftShort(y));
    z = itof(leftShort(z));

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);

    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    int density = 12;
    int tracer  = "DakkaTracer";
    
    if (GetCVar("dakka_cl_lesseffects") > 0)
    {
        density = 32;
        tracer = "DakkaTracerBright";
    }

    int last = 0, dist = 0;

    for (i = 16; i < magI; i += density)
    {
        Spawn(tracer, x+(vx*i), y+(vy*i), z+(vz*i));

        dist += i - last;
        Delay(dist / 256);
        dist %= 256;

        last = i;
    }
}


#define BFG_ZOFF            -21.0

#define BFG_HELIXRADIUS_X   16.0
#define BFG_HELIXRADIUS_Y   16.0
#define BFG_HELIX_PERIOD    2048
#define BFG_HELIX_SPEED     128
#define BFG_HELIX_START     32
#define BFG_HELIX_STEP      16

int TempCoords[PLAYERMAX][3];
int PlayerCoords[PLAYERMAX][4];

script 460 (int tx, int ty, int tz)
{
    if (!IsServer) { terminate; }
    int pln = PlayerNumber();
    int mytid = defaultTID(-1);

    int i;
    int x, y, z;
    int vx, vy, vz, mag, magI;

    x  = GetActorX(0); y =  GetActorY(0);  z = GetActorZ(0) + GetActorViewHeight(mytid) + BFG_ZOFF;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    for (i = 24; i < magI; i += 16)
    {
        TempCoords[pln][0] = (vx * i);
        TempCoords[pln][1] = (vy * i);
        TempCoords[pln][2] = (vz * i);
        GiveInventory("DakkaBFGInstantBeam_Item", 1);
        //Spawn("DakkaBFGBeam_Server", x+(vx*i), y+(vy*i), z+(vz*i));
    }

    int wait;
    int last = BFG_HELIX_START;

    for (i = BFG_HELIX_START; i < magI; i += BFG_HELIX_STEP)
    {
        TempCoords[pln][0] = (vx * i);
        TempCoords[pln][1] = (vy * i);
        TempCoords[pln][2] = (vz * i);
        GiveInventory("DakkaBFGMainBeam_Item", 1);
        //Spawn("DakkaBFGBeam_Server", x+(vx*i), y+(vy*i), z+(vz*i));

        wait += (i - last);
        Delay(wait / BFG_HELIX_SPEED);
        wait %= BFG_HELIX_SPEED;

        last = i;
    }
}

script 461 (int tx, int ty, int tz) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }

    int pln = PlayerNumber();
    int mytid = defaultTID(-1);
    int i, k;
    int x, y, z;
    int vx, vy, vz, mag, magI;
    int hx, hy, hz;

    // We do this so that the beam goes from the actual source to the actual destination
    //  as accurately as possible.
    // Given how deadly the BFG beam is, a misdraw could have huge consequences.
    if (PlayerCoords[pln][3] == Timer())
    {
        x = PlayerCoords[pln][0];
        y = PlayerCoords[pln][1];
        z = PlayerCoords[pln][2];
    }
    else
    {
        x = GetActorX(0);
        y = GetActorY(0);
        z = GetActorZ(0);
    }

    z += GetActorViewHeight(mytid);
    z += BFG_ZOFF;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    int angle =  VectorAngle(vx, vy);
    int pitch = -VectorAngle(magnitudeTwo_f(vx, vy), vz);

    // Precalculate matrix multipliers
    // look at helix.txt for how I got to what I did
    
    int mx_x = FixedMul(cos(angle), cos(pitch));
    int mx_y = -sin(angle);
    int mx_z = FixedMul(cos(angle), sin(pitch));

    int my_x = FixedMul(sin(angle), cos(pitch));
    int my_y = cos(angle);
    int my_z = FixedMul(sin(angle), sin(pitch));

    int mz_x = -sin(pitch);
    int mz_z = cos(pitch);

    for (i = 48; i < magI; i += 16)
    {
        Spawn("DakkaBFGBeam_Client", x+(vx*i), y+(vy*i), z+(vz*i));
    }

    int wait;
    int last = BFG_HELIX_START;
    int t = unusedTID(20000, 30000);

    int ex, ey, ez;

    for (i = BFG_HELIX_START; i < magI; i += BFG_HELIX_STEP)
    {
        if (!GetCVar("dakka_cl_lesseffects"))
        {
            k = itof(i) / BFG_HELIX_PERIOD;
            hx = itof(i);
            hy = FixedMul(sin(k), BFG_HELIXRADIUS_X);
            hz = FixedMul(cos(k), BFG_HELIXRADIUS_Y);

            ex = FixedMul(hx, mx_x) + FixedMul(hy, mx_y) + FixedMul(hz, mx_z);
            ey = FixedMul(hx, my_x) + FixedMul(hy, my_y) + FixedMul(hz, my_z);
            ez = FixedMul(hx, mz_x)                      + FixedMul(hz, mz_z);

            Spawn("DakkaBFGBeam_Helix",  x+ex, y+ey, z+ez, t);

            ex = FixedMul(hy, mx_y) + FixedMul(hz, mx_z);
            ey = FixedMul(hy, my_y) + FixedMul(hz, my_z);
            ez = FixedMul(hz, mz_z);

            SetActorVelocity(t, ex / 16, ey / 16, ez / 16, 0,0);
            Thing_ChangeTID(t, 0);

            Spawn("DakkaBFGBeam_HelixCenter", x+(vx*i), y+(vy*i), z+(vz*i));
        }
        else
        {
            Spawn("DakkaBFGBeam_HelixCenter_LessEffects", x+(vx*i), y+(vy*i), z+(vz*i));
        }

        wait += (i - last);
        Delay(wait / BFG_HELIX_SPEED);
        wait %= BFG_HELIX_SPEED;

        last = i;
    }
}

script 462 (int which)
{
    int ret = 0;
    int pln = PlayerNumber();

    switch (which)
    {
        case 0: ret = TempCoords[pln][0]; break;
        case 1: ret = TempCoords[pln][1]; break;
        case 2: ret = TempCoords[pln][2] + BFG_ZOFF; break;
    }

    SetResultValue(ret);
}

script 463 (int x, int y, int z)
{
    int pln = PlayerNumber();

    PlayerCoords[pln][0] = x;
    PlayerCoords[pln][1] = y;
    PlayerCoords[pln][2] = z;
    PlayerCoords[pln][3] = Timer();
}


script 464 (int magMin, int magMax, int add)
{
    magMin *= 0.01;
    magMax *= 0.01;
    if (magMin > magMax) { magMin ^= magMax; magMax ^= magMin; magMin ^= magMax; }

    int mag = random(magMin, magMax);
    int angle = random(0, 1.0);
    int pitch = random(-0.25, 0.25);

    int x = FixedMul(mag, FixedMul(cos(angle), cos(pitch)));
    int y = FixedMul(mag, FixedMul(sin(angle), cos(pitch)));
    int z = FixedMul(mag, -sin(pitch));

    SetActorVelocity(0, x, y, z, add, 1);
}

script 467 (int degrees, int ticsup, int ticsdown) clientside
{
    if (degrees == 0) { terminate; }

    int recoilFactor = percFloat(0, middle(0, GetCVar("dakka_cl_recoil"), 1000));
    if (recoilFactor <= 0 && ticsup >= 0) { terminate; }
    if (GetCVar("sv_nofreelook")) { terminate; }

    degrees = itof(degrees);
    if (degrees < 0) { degrees /= -100; }

    degrees = FixedMul(degrees, recoilFactor);

    int qCurve, oldPitch, newPitch, pitchDiff, i;
    int amplitude = degrees / 2;
    int doDownRecoil = 1;
    ticsup = abs(ticsup);

    if (ticsdown < 0)
    {
        if (GetCVar("freelook")) { doDownRecoil = 0; }
        else { ticsdown = -ticsdown; }
    }

    if (ticsup > 0)
    {
        qCurve = degrees / pow(ticsup, 2);  // this is a
        newPitch = qCurve * pow(ticsup, 2);

        for (i = 0; i < ticsup; i++)
        {
            oldPitch = newPitch;
            // y = a(x-h)**2 + k
            newPitch = qCurve * pow((i+1)-ticsup, 2);
            pitchDiff = (newPitch - oldPitch) / 360;

            SetActorPitch(0, GetActorPitch(0) + pitchDiff);
            Delay(1);
        }
    }
    else
    {
        SetActorPitch(0, GetActorPitch(0) - (degrees / 360));
    }

    int totalDown = 0;

    if (doDownRecoil)
    {
        if (ticsdown > 0)
        {
            newPitch = 0;

            if (GetCVar("dakka_cl_jerkyrecoil"))
            {
                qCurve = -degrees / pow(ticsdown, 2); // this is also a
                newPitch = qCurve * pow(ticsdown, 2);

                for (i = 0; i < ticsdown; i++)
                {
                    oldPitch = newPitch;
                    // y = a(x-h)**2 + k
                    newPitch = qCurve * pow((i+1)-ticsdown, 2);
                    pitchDiff = (newPitch - oldPitch) / 360;
                    totalDown += pitchDiff;

                    SetActorPitch(0, GetActorPitch(0) + pitchDiff);
                    Delay(1);
                }
            }
            else
            {
                // y = (a/2) * sin(x) + (a/2)

                for (i = 0; i <= ticsdown; i++)
                {
                    oldPitch = newPitch;
                    newPitch = -FixedMul(amplitude, cos(itof(i) / (ticsdown*2))) + amplitude;
                    pitchDiff = (newPitch - oldPitch) / 360;
                    totalDown += pitchDiff;

                    SetActorPitch(0, GetActorPitch(0) + pitchDiff);
                    Delay(1);
                }
            }

            int pitchLeft = (degrees / 360) - totalDown;
            SetActorPitch(0, GetActorPitch(0) + pitchLeft);
        }
        else
        {
            SetActorPitch(0, GetActorPitch(0) + (degrees / 360));
        }
    }
}

script 468 (int a1)
{
    //if (ConsolePlayerNumber() == -1) { terminate; }
    SetActivatorToTarget(0);

    Log(d:ClassifyActor(0), s:" (pln: ", d:PlayerNumber(), s:") ", d:a1);
}

script 470 (int which, int a1, int a2) clientside
{
    int pln = PlayerNumber();
    int ret = 0;

    switch (which)
    {
      case 0:
        ret = !!GetCVar("dakka_cl_lesseffects");
        break;
    }

    SetResultValue(ret);
}

script 471 death
{
    int isbrutal = 0;
    int myTID = defaultTID(-1);
    int aTID = unusedTID(27000, 37000);

    if (Spawn("BrutalPistol", GetActorX(0), GetActorY(0), GetActorZ(0), aTID))
    {
        Thing_Remove(aTID);
        isbrutal = 1;
    }

    SetActivatorToTarget(0);

    int gotAgitated = CheckInventory("IAmAgitate");

    SetActivator(myTID);

    if (gotAgitated && isbrutal)
    {
        Print(s:"Maybe you shouldn't play Dakka with Brutal Doom.");
    }
}
