#define SCRAPBASE           1000
#define CELLSCRAP_BATCH     20
#define FLAMERSCRAP_BATCH   16

#define P_FULLHEAL_MIN      50
#define P_FULLHEAL_MAX      250
#define P_FULLHEAL_PERCENT  0.7

#define Am_Pistol       0
#define Am_Shell        1
#define Am_ShotNade     2
#define Am_GyroShell    3
#define Am_Chaingun     4
#define Am_RainNade     5
#define Am_Rocket       6
#define Am_Cell         7
#define Am_Scrap        8
#define Am_Flamer       9

#define AMMOTYPES       10
#define WEPTYPES        12
#define BPAKTYPES       4
#define MONTYPES        19

int IsServer = 0;
int Client_Class = -1;
int Client_Score = -1;

int CtoS_NoScore[PLAYERMAX];
int CtoS_SwitchOnPickup[PLAYERMAX];

int CVar_Rearm[AMMOTYPES];

int CVar_Rearm_Names[AMMOTYPES] = 
{
    "dakka_rearm_10mm",
    "dakka_rearm_shell",
    "dakka_rearm_shotnade",
    "dakka_rearm_gyroshell",
    "dakka_rearm_5mm",
    "dakka_rearm_rainnade",
    "dakka_rearm_rocket",
    "dakka_rearm_cell",
    "dakka_rearm_scrap",
    "dakka_rearm_flamer",
};

int DakkaBackpackLookup[BPAKTYPES] =
{
    "Backpack",
    "BagOfHolding",
    "AmmoSatchel",
    "DakkaBackpackItem",
};

int DakkaAmmoLookup[AMMOTYPES] =
{
    "DakkaBullet_10mm",
    "DakkaShells",
    "DakkaShotGrenades",
    "DakkaGyroShells",
    "DakkaBullet_5mm",
    "DakkaRainGrenades",
    "DakkaRockets",
    "DakkaCells",
    "DakkaScrap",
    "DakkaFlamerFuel",
};

int DakkaMonsterLookup[MONTYPES] =
{
    "Dakka_Zombiedude",
    "Dakka_Shotgundude",
    "Dakka_Chaingundude",
    "Dakka_Impdude",
    "Dakka_Demondude",
    "Dakka_Shydude",
    "Dakka_Cacodude",
    "Dakka_Souldude",
    "Dakka_Paindude",
    "Dakka_Dumbdude",
    "Dakka_Spiderdude",
    "Dakka_Fatdude",
    "Dakka_Knightdude",
    "Dakka_Nobledude",
    "Dakka_Skinnydude",
    "Dakka_Cyberdude",
    "Dakka_Smartdude",
    "Dakka_Commiedude",
    "Dakka_Underagedude",
};

int DakkaMonsterPointValues[MONTYPES] =
{
    20,
    30,
    70,
    60,
    150,
    150,
    400,
    100,
    400,
    300,
    500,
    600,
    500,
    1000,
    700,
    4000,
    3000,
    50,
    100,
};

#define AL_SMALLCOUNT       0
#define AL_BIGCOUNT         1
#define AL_BACKPACKCOUNT    2
#define AL_MINSTART         3
#define AL_MAXSTART         4
#define AL_STARTDIV         5

int DakkaAmmoLookup_Counts[AMMOTYPES][6] =
{
    {16,    80,     64,     100,    250,    2},     // 10mm round
    {4,     20,     16,     8,      20,     5},     // shell
    {2,     8,      8,      2,      8,      5},     // shotnade
    {4,     12,     8,      4,      8,      5},     // gyro shell
    {25,    100,    100,    25,     400,    2},     // 5mm round, of which WE WANT A LOT OF
    {3,     12,     6,      4,      4,      5},     // rain grenade
    {2,     10,     10,     5,      10,     4},     // rocket
    {20,    100,    80,     20,     80,     4},     // cell
    {48,    192,    0,      48,     96,     5},     // scrap
    {12,    60,     24,     6,      36,     2},     // flamer fuel
};

#define Wep_Fist            0
#define Wep_Chainsaw        1
#define Wep_Scrapper        2
#define Wep_Pistol          3
#define Wep_Pistols         4
#define Wep_Shotgun         5
#define Wep_SuperShotgun    6
#define Wep_Chaingun        7
#define Wep_Minigun         8
#define Wep_RocketLauncher  9
#define Wep_PlasmaRifle     10
#define Wep_BFG9000         11

int DakkaWepLookup[WEPTYPES] =
{
    " B-Fists ",
    " B-Chainsaw ",
    " B-Scrapper ",
    " B-Pistol ",
    " B-Pistols ",
    " B-Shotgun ",
    " B-Super Shotgun ",
    " B-Chaingun ",
    " B-Minigun ",
    " B-Rocket Launcher ",
    " B-Plasma Rifle ",
    " B-BFG9000 ",
};

#define WL_AMMO1_INDEX  0
#define WL_AMMO1_COUNT  1
#define WL_AMMO2_INDEX  2
#define WL_AMMO2_COUNT  3

int DakkaWepLookup_Ammo[WEPTYPES][4] =
{
    {-1,            0,      -1,             0},     // fist
    {-1,            0,      -1,             0},     // chainsaw
    {Am_Scrap,      48,     -1,             0},     // scrapper
    {Am_Pistol,     20,     -1,             0},     // pistol
    {Am_Pistol,     40,     -1,             0},     // pistols
    {Am_Shell,      8,      Am_ShotNade,    4},     // shotgun
    {Am_Shell,      16,     Am_GyroShell,   4},     // super shotgun
    {Am_Chaingun,   80,     Am_RainNade,    4},     // chaingun
    {Am_Chaingun,   160,    Am_Flamer,      24},    // minigun
    {Am_Rocket,     10,     -1,             0},     // rocket launcher
    {Am_Cell,       40,     -1,             0},     // plasma
    {Am_Cell,       100,    -1,             0},     // BFG
};


#define AMMOCOUNT       28

int DakkaAmmoFrom[AMMOCOUNT] =
{
    // DOOM
    "Clip",
    "Shell",
    "RocketAmmo",
    "Cell",

    // HERETIC
    "GoldWandAmmo",
    "BlasterAmmo",
    "CrossbowAmmo",
    "PhoenixRodAmmo",
    "SkullRodAmmo",
    "MaceAmmo",

    // HEXEN
    "Mana1",
    "Mana2",

    // STRIFE
    "ClipOfBullets",
    "ElectricBolts",
    "PoisonBolts",
    "MiniMissiles",
    "HEGrenadeRounds",
    "PhosphorusGrenadeRounds",
    "EnergyPod",

    // COMPLEX DOOM
    "BulletMag",
    "NewShell",
    "Missile",
    "NewCell",

    // METROOD
    "MissileAmmo",
    "SuperMissileAmmo",
    "PowerBombAmmo",

    // BUTTHOLD
    "Mines",
    "Gas",
};

#define AMMOTRANSCOUNT  4

int DakkaAmmoTo[AMMOCOUNT][AMMOTRANSCOUNT * 2] =
{
    // DOOM
    {Am_Pistol,      1.0,       Am_Chaingun,    0.5,    Am_RainNade,    0.08,   Am_Flamer,      0.1},
    {Am_Shell,       1.0,       Am_ShotNade,    0.25,   Am_GyroShell,   0.25,   0,              0.0},
    {Am_Rocket,      2.0,       Am_ShotNade,    0.6,    Am_GyroShell,   0.8,    Am_RainNade,    0.8},
    {Am_Cell,        1.0,       0,              0.0,    0,              0.0,    0,              0.0},

    // HERETIC                                                                                  
    {Am_Pistol,      1.5,       Am_Chaingun,    0.5,    0,              0.0,    0,              0.0},
    {Am_Chaingun,    1.5,       Am_RainNade,    0.2,    Am_Flamer,      0.3,    0,              0.0},
    {Am_Shell,       1.0,       Am_ShotNade,    0.2,    Am_GyroShell,   0.4,    0,              0.0},
    {Am_Rocket,      2.0,       Am_ShotNade,    0.6,    Am_GyroShell,   0.8,    Am_RainNade,    0.8},
    {Am_Cell,        1.0,       0,              0.0,    0,              0.0,    0,              0.0},
    {Am_Cell,        1.0,       Am_Rocket,      0.1,    0,              0.0,    0,              0.0},

    // HEXEN
    {Am_Pistol,      1.6,       Am_Shell,       0.335,  Am_Chaingun,    1.0,    Am_Flamer,      0.1},
    {Am_Cell,        1.0,       Am_Rocket,      0.2,    Am_ShotNade,    0.2,    Am_GyroShell,   0.4},

    // STRIFE                                                                                   
    {Am_Pistol,      1.0,       Am_Chaingun,    0.5,    0,              0.0,    0,              0.0},
    {Am_Shell,       0.5,       Am_ShotNade,    0.05,   0,              0.0,    0,              0.0},
    {Am_Shell,       2.0,       Am_ShotNade,    0.4,    Am_GyroShell,   0.8,    0,              0.0},
    {Am_Rocket,      0.5,       Am_GyroShell,   0.5,    0,              0.0,    0,              0.0},
    {Am_Rocket,      1.0,       Am_GyroShell,   2.0,    Am_RainNade,    0.7,    0,              0.0},
    {Am_Rocket,      2.5,       Am_GyroShell,   4.0,    Am_RainNade,    2.0,    0,              0.0},
    {Am_Cell,        1.0,       0,              0.0,    0,              0.0,    0,              0.0},

    // COMPLEX DOOM                                                                             
    {Am_Pistol,      1.0,       Am_Chaingun,    0.5,    Am_RainNade,    0.08,   0,              0.0},
    {Am_Shell,       1.0,       Am_ShotNade,    0.25,   Am_GyroShell,   0.25,   0,              0.0},
    {Am_Rocket,      2.0,       Am_ShotNade,    0.6,    Am_GyroShell,   0.8,    Am_RainNade,    0.8},
    {Am_Cell,        1.0,       0,              0.0,    0,              0.0,    0,              0.0},

    // METROOD
    // I massively bumped up the missile ammo rates, because killing 50 zombies
    //   and getting 40 bullets - for both guns combined - is horrible.
    {Am_Pistol,      80.0,      Am_Shell,       16.0,   Am_Chaingun,    40.0,   0,              0.0},
    {Am_ShotNade,    4.0,       Am_GyroShell,   8.0,    Am_RainNade,    4.0,    Am_Rocket,      5.0},
    {Am_GyroShell,   16.0,      Am_RainNade,    8.0,    Am_Rocket,      10.0,   Am_Cell,        50.0},

    // STRONGBUTT
    {Am_Scrap,       18.0,      Am_Rocket,      1.0,    0,              0.0,    0,              0.0},
    {Am_Flamer,      0.2,       Am_Cell,        1.0,    0,              0.0,    0,              0.0},
};

int DakkaSpawnLocks[PLAYERMAX];



#define TMP_CHECKVARS       7

#define TMP_LEFTFIRE        0
#define TMP_RIGHTFIRE       1
#define TMP_LEFTCLICK       2
#define TMP_RIGHTCLICK      3
#define TMP_SSGAGAIN        4
#define TMP_RELOADSSG       5
#define TMP_INFINITEAMMO    6

int DakkaTIDs[PLAYERMAX];
int TempChecks[TMP_CHECKVARS] = {0};
int TempItems[TMP_CHECKVARS] =
{
    "MainFired",
    "AltFired",
    "MainClicked",
    "AltClicked",
    "FireSSGAgain",
    "ReloadSSG",
    "DakkaInfiniteAmmo",
};

int MapStart_BasePoints;
int MapStart_BaseMonsters;
int MapStart_AveragePoints;
int MapStart_FullHealPoints;
