function int d_cvarinfo(void)
{
    return GetCVar("dakka_usescvarinfo") == 138973;
}

function void d_setcvar(int name, int val)
{
    if (d_cvarinfo())
    {
        SetCVar(name, val);
    }
    else
    {
        ConsoleCommand(StrParam(s:"set ", s:name, s:" ", d:val));
        ConsoleCommand(StrParam(s:"archivecvar ", s:name));
    }
}

function int d_defaultcvar(int name, int val)
{
    int ret = GetCVar(name);

    if (!(ret || d_cvarinfo()))
    {
        d_setcvar(name, val);
        return val;
    }

    return ret;
}

function int canJump(void)
{
    return !GetCVar("sv_nojump");
}

function void removeAlienAmmo(void)
{
    int i, a;

    for (i = 0; i < AMMOCOUNT; i++)
    {
        a = DakkaAmmoFrom[i];
        if (CheckInventory(a)) { TakeInventory(a, 0x7FFFFFFF); }
    }
}

function int getKnownWeaponIndex(int wep)
{
    int i;

    for (i = 0; i < WEPCOUNT; i++)
    {
        if (!strcmp(wep, DakkaKnownGuns[i][0])) { return i; }
    }

    return -1;
}

function int getCurrentWeaponIndex(void)
{
    int i;

    for (i = 0; i < WEPCOUNT; i++)
    {
        if (CheckWeapon(DakkaKnownGuns[i][0])) { return i; }
    }

    return -1;
}

function int getKnownArmorIndex(int arm)
{
    int i;

    for (i = 0; i < ARMORCOUNT; i++)
    {
        if (!strcmp(arm, DakkaKnownArmors[i][0])) { return i; }
    }

    return -1;
}

function int getCurrentArmorIndex(void)
{
    if (CheckInventory("Armor") <= 0) { return -1; }

    int i, n, pln = PlayerNumber();

    for (i = 0; i < ARMORCOUNT; i++)
    {
        n = DakkaKnownArmors[i][0];
        if (GetArmorType(n, pln)) { return i; }
    }

    return -1;
}

function int getKnownHealthIndex(int hel)
{
    int i;

    for (i = 0; i < HEALTHCOUNT; i++)
    {
        if (!strcmp(hel, DakkaKnownHealth[i][0])) { return i; }
    }

    return -1;
}

function int GetDakkaAmmoIndex(int item)
{
    int i;

    for (i = 0; i < AMMOTYPES; i++)
    {
        if (!strcmp(item, DakkaAmmoLookup[i])) { return i; }
    }

    return -1;
}

function int GetDakkaWepIndex(int item)
{
    int i;

    for (i = 0; i < WEPTYPES; i++)
    {
        if (!strcmp(item, DakkaWepLookup[i])) { return i; }
    }

    return -1;
}

function int GetDakkaBackpackIndex(int item)
{
    int i;

    for (i = 0; i < BPAKTYPES; i++)
    {
        if (!strcmp(item, DakkaBackpackLookup[i])) { return i; }
    }

    return -1;
}


function void translateAmmo(void)
{
    int i,   ammo,   count;
    int j, toAmmo, toCount, toMult;

    for (i = 0; i < AMMOCOUNT; i++)
    {
        ammo  = DakkaAmmoFrom[i];
        count = CheckInventory(ammo);

        if (count == 0) { continue; }

        for (j = 0; j < AMMOTRANSCOUNT; j++)
        {
            toAmmo = DakkaAmmoTo[i][0 + (2 * j)];
            toAmmo = DakkaAmmoLookup[toAmmo];
            toMult = DakkaAmmoTo[i][1 + (2 * j)];

            toCount = FixedMul(count, toMult);

            if (toCount == 0 || StrLen(toAmmo) == 0) { continue; }
            GiveInventory(toAmmo, toCount);
        }

        TakeInventory(ammo, count);
    }
}

function int translateGuns(void)
{
    int i, j, fromWep, toWep, take;
    int latest = "";

    for (i = 0; i < WEPCOUNT; i++)
    {
        fromWep = DakkaKnownGuns[i][0];
        if (!CheckInventory(fromWep) || StrLen(fromWep) == 0) { continue; }

        take = 0;
        
        for (j = 0; j < REPLCOUNT; j++)
        {
            toWep = DakkaKnownGuns[i][3+j];
            if (StrLen(toWep) == 0) { continue; }

            take = 1;
            if (strcmp(toWep, "None") == 0) { continue; }

            latest = toWep;
            GiveInventory(toWep, 1);
        }

        if (take) { TakeInventory(fromWep, 0x7FFFFFFF); }
    }
    
    return latest;
}


function int DakkaClassNum(void)
{
    int i, j, item, success;
    int pln = PlayerNumber();

    for (i = 0; i < CLASSCOUNT; i++)
    {
        success = 1;

        for (j = 0; j < CLASSITEMCOUNT; j++)
        {
            item = DakkaClassItems[i][j];
            if (StrLen(item) == 0) { continue; }

            if (!CheckInventory(item))
            {
                success = 0;
                break;
            }
        }

        if (success) { return i; }
    }

    return -1;
}

int _tmpMsgs[MSGCOUNT];

function int chooseMessage(int class, int index, int domore)
{
    int ret = "";
    int count = 0;
    int i, msg;

    if (!GetCVar("dakka_cl_moremessages") || !domore)
    {
        int maybeRet = DakkaMessages[class][index][0];
        if (StrLen(msg)) { ret = maybeRet; }
    }
    else
    {
        for (i = 0; i < MSGCOUNT; i++)
        {
            msg = DakkaMessages[class][index][i];
            if (StrLen(msg) == 0) { continue; }

            _tmpMsgs[count++] = msg;
        }

        if (count > 0)
        {
            ret = _tmpMsgs[random(0, count-1)];
        }
    }

    return ret;
}

int _tmpMsgs_low[LOWMSGCOUNT];

function int chooseLowHealthMessage(int index, int domore)
{
    int ret = "<insert message here>";
    int count = 0;
    int i, msg;

    if (!GetCVar("dakka_cl_moremessages") || !domore)
    {
        int maybeRet = DakkaLowHealthMessages[index][0];
        if (StrLen(msg)) { ret = maybeRet; }
    }
    else
    {
        for (i = 0; i < LOWMSGCOUNT; i++)
        {
            msg = DakkaLowHealthMessages[index][i];
            if (StrLen(msg) == 0) { continue; }

            _tmpMsgs[count++] = msg;
        }

        if (count > 0)
        {
            ret = _tmpMsgs[random(0, count-1)];
        }
    }

    return ret;
}


function void CalcTotalMonsterPoints(void)
{
    int i;
    int name, count;

    int totalMons   = 0;
    int totalPoints = 0;

    for (i = 0; i < MONTYPES; i++)
    {
        name = DakkaMonsterLookup[i];
        count = ThingCountName(name, 0);

        totalMons   += count;
        totalPoints += count * DakkaMonsterPointValues[i];
    }

    MapStart_BasePoints     = totalPoints;
    MapStart_BaseMonsters   = totalMons;

    if (MapStart_BaseMonsters == 0)
    {
        MapStart_AveragePoints = 0;
    }
    else
    {
        MapStart_AveragePoints  = totalPoints / totalMons;
    }
}

function int GetMapAmmo(int index)
{
    if (index < 0 || index >= STARTAMMOCOUNT) { return 0; }
    int item  = MapAmmoItems[index];
    int count = ThingCountName(item, 0);

    return count;
}

function void AddMapAmmo_Index(int index, int count)
{
    int class   = MapAmmoNumbers[index][SA_CLASS];
    int slot    = MapAmmoNumbers[index][SA_SLOT];
    int dropped = MapAmmoNumbers[index][SA_DROPPED];
    int wep, ammo, bpak;
    int item, give;
    int i, j;

    for (i = 0; i < PICKUPSLOTCOUNT; i++)
    {
        item = DakkaPickups[class + 1][slot][i];
        if (StrLen(item) == 0) { continue; }

        wep  = GetDakkaWepIndex(item);
        ammo = GetDakkaAmmoIndex(item);
        bpak = GetDakkaBackpackIndex(item);

        if (bpak != -1)
        {
            for (j = 0; j < AMMOTYPES; j++)
            {
                AddMapAmmo(j, count * DakkaAmmoLookup_Counts[j][AL_BACKPACKCOUNT]);
            }
        }
        else if (wep != -1)
        {
            // the bit shift divides by two if dropped
            
            j = DakkaWepLookup_Ammo[wep][WL_AMMO1_INDEX];
            if (j != -1)
            {
                give = (count * DakkaWepLookup_Ammo[wep][WL_AMMO1_COUNT]) >> (!!dropped);
                AddMapAmmo(j, give);
            }

            j = DakkaWepLookup_Ammo[wep][WL_AMMO2_INDEX];
            if (j != -1)
            {
                give = (count * DakkaWepLookup_Ammo[wep][WL_AMMO2_COUNT]) >> (!!dropped);
                AddMapAmmo(j, give);
            }
        }
        else
        {
            j = condFalse(DakkaPickupCounts[class + 1][slot][i], 1);
            give = (count * j) >> (!!dropped);
            AddMapAmmo(ammo, give);
        }
    }
}

function void AddMapAmmo(int index, int count)
{
    if (index < 0 || index >= AMMOTYPES) { return; }
    TempMapAmmos[index] += count;
}

function void CalculateMapAmmoCount(void)
{
    int i, j;
    int mapitem;
    int itemcount;

    for (i = 0; i < STARTAMMOCOUNT; i++)
    {
        mapitem = MapAmmoItems[i];
        itemcount = GetMapAmmo(i);
        if (itemcount == 0) { continue; }

        AddMapAmmo_Index(i, itemcount);
    }

    for (i = 0; i < AMMOTYPES; i++)
    {
        j = TempMapAmmos[i];
        Global_MapAmmoCounts[i] = max(Global_MapAmmoCounts[i], j);
    }
}


int _tmpUsableAmmos[AMMOTYPES];

function void Dakka_StartMap(int mode)
{
    int i, wep, ammo, amax, cap, lowCap;

    for (i = 0; i < AMMOTYPES; i++) { _tmpUsableAmmos[i] = 0; }

    for (i = 0; i < WEPTYPES; i++)
    {
        if (CheckInventory(DakkaWepLookup[i]))
        {
            ammo = DakkaWepLookup_Ammo[i][WL_AMMO1_INDEX];
            if (ammo != -1) { _tmpUsableAmmos[ammo] = 1; }

            ammo = DakkaWepLookup_Ammo[i][WL_AMMO2_INDEX];
            if (ammo != -1) { _tmpUsableAmmos[ammo] = 1; }
        }
    }

    switch (mode)
    {
      case -1:
        break;

      // Default behaviour - reset ammo based on how much was on this
      //   and previous maps, capping it between predefined minimum and
      //   maximum values
      default:
        TakeInventory("Armor", 0x7FFFFFFF);
        SetActorProperty(0, APROP_Health, getMaxHealth());

        for (i = 0; i < AMMOTYPES; i++)
        {
            ammo = DakkaAmmoLookup[i];
            TakeInventory(ammo, 0x7FFFFFFF);
            if (_tmpUsableAmmos[i] <= 0) { continue; }

            amax    = Global_MapAmmoCounts[i] / DakkaAmmoLookup_Counts[i][AL_STARTDIV];
            lowCap  = DakkaAmmoLookup_Counts[i][AL_MINSTART];
            cap     = DakkaAmmoLookup_Counts[i][AL_MAXSTART];
            GiveInventory(ammo, middle(lowCap, amax, cap));
        }
        break;

      // Pistol start every map
      case 1:
        TakeInventory("Armor", 0x7FFFFFFF);
        SetActorProperty(0, APROP_Health, getMaxHealth());

        for (i = 0; i < WEPTYPES; i++)
        {
            TakeInventory(DakkaWepLookup[i], 0x7FFFFFFF);
        }

        for (i = 0; i < AMMOTYPES; i++)
        {
            ammo = DakkaAmmoLookup[i];
            TakeInventory(ammo, 0x7FFFFFFF);
        }

        for (i = 0; i < BPAKTYPES; i++)
        {
            TakeInventory(DakkaBackpackLookup[i], 0x7FFFFFFF);
        }

        GiveInventory(" B-Pistols ", 1);
        GiveInventory(" B-Pistol ", 1);
        GiveInventory(" B-Fists ", 1);

        i = 100 - CheckInventory("DakkaBullet_10mm");

        if (i < 0)  { TakeInventory("DakkaBullet_10mm", -i); }
        else if (i) { GiveInventory("DakkaBullet_10mm",  i); }
        break;

      // Give every weapon sans BFG9000 and Chainsaw, max out ammo, strip backpack
      case 2:
        TakeInventory("Armor", 0x7FFFFFFF);
        SetActorProperty(0, APROP_Health, getMaxHealth());
       
        for (i = 0; i < BPAKTYPES; i++)
        {
            if (CheckInventory(DakkaBackpackLookup[i]))
            {
                TakeInventory(DakkaBackpackLookup[i], 0x7FFFFFFF);
            }
        }

        for (i = 0; i < WEPTYPES; i++)
        {
            wep = DakkaWepLookup[i];
            if ((i == Wep_Chainsaw) || (i == Wep_BFG9000))
            {
                TakeInventory(wep, 0x7FFFFFFF);
                continue;
            }

            if (CheckInventory(wep)) { continue; }

            GiveInventory(wep, 1);
        }

        for (i = 0; i < AMMOTYPES; i++)
        {
            ammo = DakkaAmmoLookup[i];
            TakeInventory(ammo, 0x7FFFFFFF);
            GiveInventory(ammo, GetAmmoCapacity(ammo));
        }
        break;

      // Give every weapon sans Chainsaw, max out ammo, give backpack
      case 3:
        TakeInventory("Armor", 0x7FFFFFFF);
        SetActorProperty(0, APROP_Health, getMaxHealth());

        GiveInventory("DakkaBackpackItem", 1);
       
        for (i = 0; i < WEPTYPES; i++)
        {
            wep = DakkaWepLookup[i];

            if (i == Wep_Chainsaw)
            {
                TakeInventory(wep, 0x7FFFFFFF);
                continue;
            }

            if (CheckInventory(wep)) { continue; }

            GiveInventory(DakkaWepLookup[i], 1);
        }

        for (i = 0; i < AMMOTYPES; i++)
        {
            ammo = DakkaAmmoLookup[i];
            TakeInventory(ammo, 0x7FFFFFFF);
            GiveInventory(ammo, GetAmmoCapacity(ammo));
        }
        break;

      // Give every weapon sans Chainsaw, but do default ammo behaviour
      case 4:
        TakeInventory("Armor", 0x7FFFFFFF);
        SetActorProperty(0, APROP_Health, getMaxHealth());
       
        for (i = 0; i < WEPTYPES; i++)
        {
            wep = DakkaWepLookup[i];

            if (i == Wep_Chainsaw)
            {
                TakeInventory(wep, 0x7FFFFFFF);
                continue;
            }

            if (CheckInventory(wep)) { continue; }

            GiveInventory(DakkaWepLookup[i], 1);
        }

        for (i = 0; i < AMMOTYPES; i++)
        {
            ammo = DakkaAmmoLookup[i];
            TakeInventory(ammo, 0x7FFFFFFF);

            // This is commented out because we /know/ we have the weapon.
            //if (_tmpUsableAmmos[i] <= 0) { continue; }

            amax    = Global_MapAmmoCounts[i] / DakkaAmmoLookup_Counts[i][AL_STARTDIV];
            lowCap  = DakkaAmmoLookup_Counts[i][AL_MINSTART];
            cap     = DakkaAmmoLookup_Counts[i][AL_MAXSTART];
            GiveInventory(ammo, middle(lowCap, amax, cap));
        }
        break;

      // Give every weapon sans Chainsaw, but do pistol start otherwise
      case 5:
        TakeInventory("Armor", 0x7FFFFFFF);
        SetActorProperty(0, APROP_Health, getMaxHealth());
       
        for (i = 0; i < WEPTYPES; i++)
        {
            wep = DakkaWepLookup[i];

            if (i == Wep_Chainsaw)
            {
                TakeInventory(wep, 0x7FFFFFFF);
                continue;
            }

            if (CheckInventory(wep)) { continue; }

            GiveInventory(DakkaWepLookup[i], 1);
        }

        for (i = 0; i < AMMOTYPES; i++)
        {
            ammo = DakkaAmmoLookup[i];
            TakeInventory(ammo, 0x7FFFFFFF);
        }

        for (i = 0; i < BPAKTYPES; i++)
        {
            TakeInventory(DakkaBackpackLookup[i], 0x7FFFFFFF);
        }

        i = 100 - CheckInventory("DakkaBullet_10mm");

        if (i < 0)  { TakeInventory("DakkaBullet_10mm", -i); }
        else if (i) { GiveInventory("DakkaBullet_10mm",  i); }
        break;
    }
}

function int dakkaOnGround(int tid)
{
    int ctid = unusedTID(13000, 18000);
    int spawned = Spawn("DakkaFloorChecker", GetActorX(tid), GetActorY(tid), GetActorZ(tid)-4.0, ctid);
    if (spawned) { Thing_Remove(ctid); }

    return (onGround(tid) ||
        (GetActorVelZ(tid) == 0 && !spawned));
}
