#define HEALTHCOUNT 6
#define LOWMSGCOUNT 1

// NOTE: These health items don't have to actually exist!
//  So long as they're defined here, Dakka will know what to do with them.

int DakkaKnownHealth[HEALTHCOUNT][1] =
{
    {"BaseHealth"},
    {"HealthBonus"},
    {"Stimpack"},
    {"Medikit"},
    {"ComplexMedikit"},
    {"MegasphereHealth"},
};


#define HEAL_VALUECOUNT 5

#define HEAL_PICKUPPOINTS   0
#define HEAL_MAXPOINTS      1
#define HEAL_MAXMODE        2
#define HEAL_LOWPOINTS      3
#define HEAL_LOWMODE        4

// CONSTANT  - take value as is, no modification
// ADDITIVE  - add max health to value
// SCALED    - multiply max health by value (scale value should be fixed)

#define HMAX_CONSTANT   0
#define HMAX_ADDITIVE   1
#define HMAX_SCALED     2

#define HLOW_CONSTANT   0
#define HLOW_ADDITIVE   1
#define HLOW_SCALED     2

int DakkaHealthValues[HEALTHCOUNT][HEAL_VALUECOUNT] =
{
    {1,     0,      HMAX_ADDITIVE,  0,      HLOW_CONSTANT},
    {1,     100,    HMAX_ADDITIVE,  0,      HLOW_CONSTANT},
    {10,    0,      HMAX_ADDITIVE,  0,      HLOW_CONSTANT},
    {25,    0,      HMAX_ADDITIVE,  25,     HLOW_CONSTANT},
    {25,    0,      HMAX_ADDITIVE,  25,     HLOW_CONSTANT},
    {200,   200,    HMAX_CONSTANT,  0,      HLOW_CONSTANT},
};


// Low health messages override any message that would normally be displayed.
//  In case of conflicts, last one evaluated takes precedence.
//
// If picking up health gets you <insert message here> occasionally, this is
//  probably why.

int DakkaLowHealthMessages[HEALTHCOUNT][LOWMSGCOUNT] =
{
    {
        "",
    },
    {
        "",
    },
    {
        "",
    },
    {
        "$GOTMEDINEED",
    },
    {
        "Found out why Complex Doom is a piece of shit!",  // Subtlety?
    },
    {
        "",
    },
};
