#define SCOREWEPS           32
#define SCOREFIREMODES      3

#define S_FIST              0
#define S_SCRAPPER          1
#define S_PISTOL            2
#define S_SHOTGUN           3
#define S_SUPERSHOTGUN      4
#define S_CHAINGUN          5
#define S_MINIGUN           6
#define S_ROCKETLAUNCHER    7
#define S_PLASMARIFLE       8
#define S_BFG9000           9

#define SWITCHAROO_TICSPER100HP 24
#define SWITCHAROO_MINTICS      72
#define SWITCHAROO_MAXTICS      144

#define KILLSTREAK_TICSPER100HP 24
#define KILLSTREAK_MINTICS      72
#define KILLSTREAK_MAXTICS      360
#define KILLSTREAK_MULTMAX      0.25
#define KILLSTREAK_MULTINC      0.025
#define KS_COUNT    0
#define KS_TIME     1
#define KS_TIMEADD  2

#define BONEDRY_MAXHP           25
#define BONEDRY_MULTPERHP       0.02

#define AIR_MINHEIGHT           64.0
#define AIR_MULT                0.002
#define AIR_MAXMULT             0.5

#define CURVEBALL_MULT          0.2

#define SCRAPPING_MULT          0.125

int PlayerMapScores[PLAYERMAX];

// Allowing three fire modes.
//  0 - primary   (+attack)
//  1 - secondary (+altattack)
//  2 - tertiary  (some combo of the two, probably won't be used)
int PlayerWeapons_LastFired[PLAYERMAX][SCOREWEPS][SCOREFIREMODES];
int PlayerKillStreaks[PLAYERMAX][3];
int PlayerZHeight[PLAYERMAX];

#define KNOWNMELEE 15

int Brawler_KnownMelee[KNOWNMELEE] =
{
    "Fist",
    "Chainsaw",
    " B-Fists ",
    " B-Chainsaw ",
    "PunchDagger",
    "FWeapFist",
    "FWeapAxe",
    "FWeapHammer",
    "CWeapMace",
    "Staff",
    "Gauntlets",
    "Fight",
    "Knife",
    "Fist~",
    "Chainsaw~",
};

int Brawler_MeleeMults[KNOWNMELEE] = 
{
    0.5,
    0.25,
    0.25,
    0.15,
    0.5,
    0.25,
    0.15,
    0.1,
    0.3,
    0.5,
    0.25,
    0.5,
    0.25,
    0.5,
    0.25,
};


#define BONUSCOUNT  9

#define BS_BASE         0
#define BS_SPREE        1
#define BS_SWITCHAROO   2
#define BS_SCRAPPING    3
#define BS_CURVEBALL    4
#define BS_AIR          5
#define BS_BONEDRY      6
#define BS_SORELOSER    7
#define BS_BRAWLER      8

// CR_BRICK  is efficiency
// CR_GREEN  is style
// CR_ORANGE is daring

int BonusNames[BONUSCOUNT] =
{
    "Base",
    "Spree",
    "Switcharoo",
    "Scrapping",
    "Curveball",
    "Air",
    "Bone Dry",
    "Sore Loser",
    "Brawler",
};

int BonusColors[BONUSCOUNT] = 
{
    CR_YELLOW,
    CR_BRICK,
    CR_GREEN,
    CR_GREEN,
    CR_GREEN,
    CR_GREEN,
    CR_ORANGE,
    CR_ORANGE,
    CR_ORANGE,
};

int BonusValues[PLAYERMAX][BONUSCOUNT];
int LastBonus[PLAYERMAX][BONUSCOUNT];
